<?xml version="1.0" encoding="UTF-8"?>
<schema xmlns="http://purl.oclc.org/dsdl/schematron"
    xmlns:xsd="http://www.w3.org/2001/XMLSchema"
    queryBinding="xslt2">
    <title>Schematron validation for the SCAP XCCDF Reporting Format</title>
    <ns prefix="xsi" uri="http://www.w3.org/2001/XMLSchema-instance"/>
    <ns prefix="cdf" uri="http://checklists.nist.gov/xccdf/1.1"/>
    <pattern id="TestResult-required">
        <rule context="cdf:TestResult">
            <assert test="cdf:benchmark">The benchmark element must be provided in TestResult</assert>
            <assert test="cdf:identity">The identity element must be provided in TestResult</assert>
            <assert test="cdf:organization">One or more organization elements must be provided in TestResult</assert>
            <assert test="cdf:profile">The profile element must be provided in TestResult</assert>
            <assert test="@test-system">The test-system attribute must be provided in TestResult</assert>
        </rule>
    </pattern>

    <pattern id="RuleResult-required">
        <rule context="cdf:TestResult/cdf:rule-result">
            <report test="not(cdf:ident)">If a CCE exists for this RuleResult, the ident element should be used to reference it</report>
        </rule>
    </pattern>
    
    <pattern id="disallow-rule-result-fixed">
        <rule context="cdf:TestResult/cdf:rule-result">
            <assert test="not(cdf:result = 'fixed')">In rule-result result may not be 'fixed'</assert>
        </rule>
    </pattern>
    
    <pattern id="require-rule-override-details">
        <rule context="cdf:TestResult/cdf:rule-result">
            <report test="not(cdf:result = 'pass' or cdf:result = 'notchecked') and count(cdf:override) = 0">It is recommended to include an override entry for all rule-result elements with a result that is not pass or notchecked</report>
        </rule>
    </pattern>
    
    <pattern id="require-rule-override">
        <rule context="cdf:TestResult/cdf:rule-result/cdf:override">
            <assert test="cdf:old-result = ../cdf:result">In rule-result/override old-result must be '<value-of select="../cdf:result/text()"/>'</assert>
            <assert test="cdf:new-result = ../cdf:result">In rule-result/override new-result must be '<value-of select="../cdf:result/text()"/>'</assert>
        </rule>
    </pattern>
    
</schema>